#define STRICT
#include <windows.h>
int                     MonitorCount;
HMONITOR                hwnd_monitor;
HANDLE                  hm[10];
HDC                     hm_hdc[10];
RECT                    hm_rect[10];
int                     hm_number;
int                     window_count;


BOOL CALLBACK MonitorEnumProc(HMONITOR hMonitor, HDC hdcMonitor, LPRECT lprcMonitor, LPARAM dwData){

    hm[MonitorCount]=hMonitor;
    hm_hdc[MonitorCount]=hdcMonitor;
    memcpy(&hm_rect[MonitorCount], lprcMonitor, sizeof(RECT));
    if (MonitorCount<9) MonitorCount++;
    return TRUE;
}

BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam){
DWORD       pid;
RECT        rect;
int         i, hm_number_old;

    GetWindowThreadProcessId(hwnd, &pid);
    window_count++;
    if (pid==(DWORD) lParam){
        hwnd_monitor=MonitorFromWindow(hwnd, MONITOR_DEFAULTTONEAREST);
        hm_number_old=0;
        for (i=0;i<MonitorCount;i++){
            if (hm[i]==hwnd_monitor){
                hm_number_old=i;
                break;
            }

        }
        if (!IsWindowVisible(hwnd)) return TRUE;
        if (GetForegroundWindow()!=hwnd) return TRUE;
        GetWindowRect(hwnd, &rect);
        if ((rect.bottom==0)||(rect.right==0)) return TRUE;
        rect.top-=hm_rect[hm_number_old].top;
        rect.bottom-=hm_rect[hm_number_old].top;
        rect.left-=hm_rect[hm_number_old].left;
        rect.right-=hm_rect[hm_number_old].left;
        rect.top+=hm_rect[hm_number].top;
        rect.bottom+=hm_rect[hm_number].top;
        rect.left+=hm_rect[hm_number].left;
        rect.right+=hm_rect[hm_number].left;
        if (rect.left>hm_rect[hm_number].right) rect.left=0;
        if (rect.right>hm_rect[hm_number].right) rect.right=hm_rect[hm_number].right;
        if (rect.top>hm_rect[hm_number].bottom) rect.top=0;
        if (rect.bottom>hm_rect[hm_number].bottom) rect.bottom=hm_rect[hm_number].bottom;
        MoveWindow(hwnd, rect.left, rect.top, rect.right-rect.left, rect.bottom-rect.top, TRUE);
        return FALSE;
    }
    return TRUE;
}

int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrev, LPSTR lpCmdLine, int nCmdShow ){
PROCESS_INFORMATION     pi;
STARTUPINFO             si;
POINT                   point;
BOOL                    success;
int                     i;

    EnumDisplayMonitors(NULL, NULL, MonitorEnumProc, 0);
    GetCursorPos(&point);
    hwnd_monitor=MonitorFromPoint(point, MONITOR_DEFAULTTONEAREST);
    hm_number=0;
    for (i=0;i<MonitorCount;i++){
        if (hm[i]==hwnd_monitor){
            hm_number=i;
            break;
        }

    }
    Sleep(5000);
    si.cb=sizeof(STARTUPINFO);
    si.lpReserved=NULL;
    si.lpDesktop=NULL;
    si.lpTitle=NULL;
    si.cbReserved2=0;
    si.lpReserved2=NULL;
    si.dwX=hm_rect[hm_number].left;
    si.dwY=hm_rect[hm_number].top;
    si.dwXSize=hm_rect[hm_number].right;
    si.dwYSize=hm_rect[hm_number].bottom;
    si.wShowWindow=SW_SHOWDEFAULT;
    si.dwFlags=STARTF_USESHOWWINDOW|STARTF_USEPOSITION|STARTF_USESIZE;
    si.wShowWindow=SW_SHOWDEFAULT;
	success=CreateProcess(NULL, lpCmdLine, NULL, NULL, TRUE, IDLE_PRIORITY_CLASS, NULL, NULL, &si, &pi);
    i=0;
    while (EnumWindows(EnumWindowsProc, pi.dwProcessId)){
        Sleep(100);
        i++;
        if (i==300) break;
    }
    return 0;                                                                   //Ende des Programmes
}

